{-# LANGUAGE NoImplicitPrelude #-}
module Synthesizer.Causal.Spatial where

import qualified Algebra.NormedSpace.Euclidean as Euc
import qualified Algebra.Field                 as Field

import Control.Arrow (Arrow, arr, )

import NumericPrelude.Base
import NumericPrelude.Numeric


{-|
simulate an moving sounding object

convert the way of the object through 3D space
into a delay and attenuation information,
sonicDelay is the reciprocal of the sonic velocity
-}
receive3Dsound ::
   (Field.C a, Euc.C a v, Arrow arrow) =>
   a -> a -> v -> arrow v (a,a)
receive3Dsound att sonicDelay ear =
   arr ((\dist -> (sonicDelay*dist, 1/(att+dist)^2)) . Euc.norm . subtract ear)
